# 1013. 将数组分成和相等的三个部分



[url](https://leetcode-cn.com/problems/partition-array-into-three-parts-with-equal-sum/)


## 题目
给你一个整数数组 A，只有可以将其划分为三个和相等的非空部分时才返回 true，否则返回 false。

形式上，如果可以找出索引 `i+1 < j` 且满足 `A[0] + A[1] + ... + A[i] == A[i+1] + A[i+2] + ... + A[j-1] == A[j] + A[j-1] + ... + A[A.length - 1]` 就可以将数组三等分。


```
输入：[0,2,1,-6,6,-7,9,1,2,0,1]
输出：true
解释：0 + 2 + 1 = -6 + 6 - 7 + 9 + 1 = 2 + 0 + 1
输入：[0,2,1,-6,6,7,9,-1,2,0,1]
输出：false
输入：[3,3,6,5,-2,2,5,1,-9,4]
输出：true
解释：3 + 3 = 6 = 5 - 2 + 2 + 5 + 1 - 9 + 4
```


## 方法


## code

### js

```js
let canThreePartsEqualSum = A => {
    let sum = 0;
    // 遍历数组求和
    A.forEach(num => sum += num);
    // 数组A的和如果不能被3整除直接返回false
    if (sum % 3 !== 0)
        return false;
    // 遍历数组累加，每累加到目标值cnt加1， 表示又找到了1段
    sum = Math.floor(sum / 3);
    let curSum = 0, cnt = 0;
    for (let val of A) {
        curSum += val;
        if (curSum === sum) {
            cnt++;
            curSum = 0;
        }
    }
    return cnt === 3 || (cnt > 3 && sum === 0);
};
console.log(canThreePartsEqualSum([0,2,1,-6,6,-7,9,1,2,0,1]));
console.log(canThreePartsEqualSum([0,2,1,-6,6,7,9,-1,2,0,1]));
console.log(canThreePartsEqualSum([3,3,6,5,-2,2,5,1,-9,4]));
```

### go

```go
func canThreePartsEqualSum(A []int) bool {
	sum := 0
	// 遍历数组求总和
	for _, v := range A {
		sum += v
	}
	// 数组A的和如果不能被3整除直接返回false
	if sum%3 != 0 {
		return false
	}
	// 遍历数组累加，每累加到目标值cnt加1，表示又找到1段
	sum /= 3
	curSum, cnt := 0, 0
	for _, v := range A {
		curSum += v
		if curSum == sum {
			 cnt++
			 curSum = 0
		}
	}
	// 最后判断是否找到了3段（注意如果目标值是0的话可以大于3段）
	return cnt == 3 || (cnt > 3 && sum == 0)
}
```

### java

```java
class Solution {
    public boolean canThreePartsEqualSum(int[] A) {
        int sum = 0;
        // 遍历数组求总和
        for (int num : A) {
            sum += num;
        }
        // 数组A的和如果不能被3整除直接返回false
        if (sum % 3 != 0) {
            return false;
        }
        // 遍历数组累加，每累加到目标值cnt加1，表示又找到1段
        sum /= 3;
        int curSum = 0, cnt = 0;
        for (int i = 0; i < A.length; i++) {
            curSum += A[i];
            if (curSum == sum) {
                cnt++;
                curSum = 0;
            }
        }
        // 最后判断是否找到了3段（注意如果目标值是0的话可以大于3段）
        return cnt == 3 || (cnt > 3 && sum == 0);
    }
}
```

