# 111. 二叉树的最小深度

[url](https://leetcode-cn.com/problems/minimum-depth-of-binary-tree/)

## 题目

给定一个二叉树，找出其最小深度。

最小深度是从根节点到最近叶子节点的最短路径上的节点数量。

说明：叶子节点是指没有子节点的节点。



```
输入：root = [3,9,20,null,null,15,7]
输出：2
输入：root = [2,null,3,null,4,null,5,null,6]
输出：5
```

## 方法

可递归，当然也可迭代

## code

### js

```js
var minDepth = function(root) {
    // 队列
    if (root === null) return 0;
    var queue = [root];
    var depth = 1;
    while (queue.length !== 0) {
        var size = queue.length;
        while (size-- > 0) {
            var node = queue[0];
            queue = queue.slice(1, queue.length);
            if (node.left === null && node.right === null) 
                return depth;
            if (node.left !== null)
                queue.push(node.left);
            if (node.right !== null) 
                queue.push(node.right);
        }
        depth++;
    }
    return depth;
};
```

### go

```go
// 递归
func minDepth(root *TreeNode) int {
	Min := func(a int, b int) int {
		if a < b {
			return a
		} else {
			return b
		}
	}
	if root == nil {
		return 0
	}
	l := minDepth(root.Left)
	r := minDepth(root.Right)
	if l == 0 || r == 0 {
		return l + r + 1
	}
	return Min(l, r) + 1
}
// 队列
func minDepth1(root *TreeNode) int {
	if root == nil {
		return 0
	}
	q := []*TreeNode{root}
	depth := 1
	for len(q) != 0 {
		size := len(q)
		for size > 0 {
			size--
			node := q[0]
			q = q[1:]
			if node.Left == nil && node.Right == nil {
				return depth
			}
			if node.Left != nil {
				q = append(q, node.Left)
			}
			if node.Right != nil {
				q = append(q, node.Right)
			}
		}
		depth++
	}
	return depth
}
```

### java

```java
class Solution {
    public int minDepth(TreeNode root) {
        if (root == null) return 0;
        Queue<TreeNode> queue = new LinkedList<>();
        // 树不需要标记哦
        queue.add(root);
        int depth = 1;
        while (!queue.isEmpty()) {
            int size = queue.size();
            while (size-- > 0) {
                TreeNode node = queue.poll();
                if (node.left == null && node.right == null)
                    return depth;
                if (node.left != null)
                    queue.add(node.left);
                if (node.right != null)
                    queue.add(node.right);
            }
            depth++;
        }
        return depth;
    }
}
```

