# 121. 买卖股票的最佳时机

[url](https://leetcode-cn.com/problems/best-time-to-buy-and-sell-stock/)


## 题目

给定一个数组 `prices` ，它的第` i `个元素 `prices[i] `表示一支给定股票第` i `天的价格。

你只能选择某一天买入这只股票，并选择在未来的某一个不同的日子卖出该股票。设计一个算法来计算你所能获取的最大利润。

返回你可以从这笔交易中获取的最大利润。如果你不能获取任何利润，返回 0 。


```
输入：[7,1,5,3,6,4]
输出：5
解释：在第 2 天（股票价格 = 1）的时候买入，在第 5 天（股票价格 = 6）的时候卖出，最大利润 = 6-1 = 5 。
     注意利润不能是 7-1 = 6, 因为卖出价格需要大于买入价格；同时，你不能在买入前卖出股票。

输入：prices = [7,6,4,3,1]
输出：0
解释：在这种情况下, 没有交易完成, 所以最大利润为 0。
```

## 方法

动态规划

- 迭代过程当中，比较`min`和当前价格，取最小，目的是为了获取最大利润的嘛
- 其次将当前价格与`min`的差和最大差值进行比较，保留最大差值，最后该差值就是最大利润

## code

### js

```js
let maxProfit = prices => {
    if (prices === null || prices.length === 0) return -1;
    let min = prices[0];
    let max = 0;
    for (let i = 1; i < prices.length; i++) {
        min = prices[i] < min ? prices[i] : min;
        max = Math.max(max, prices[i] - min);
    }
    return max;
}

console.log(maxProfit([7,1,5,3,6,4]));
console.log(maxProfit([7,6,4,3,1]));
```

### go

```go
func maxProfit(prices []int) int {
	if prices == nil || len(prices) == 0 {
		return -1
	}
	min, max := prices[0], 0
	for i := 1; i < len(prices); i++ {
		if prices[i] < min {
			min = prices[i]
		}
		max = Max(max, prices[i] - min)
	}
	return max
}
```

### java

```java
class Solution {
    public int maxProfit(int[] prices) {
        if (prices == null || prices.length == 0) return -1;
        int min = prices[0];
        int max = 0;
        for (int i = 1; i < prices.length; i++) {
            min = prices[i] < min ? prices[i] : min;
            max = Math.max(max, prices[i] - min);
        }
        return max;
    }
}
```

