# 13. 罗马数字转整数

[url](https://leetcode-cn.com/problems/roman-to-integer/)

## 题目

```
罗马数字包含以下七种字符: I， V， X， L，C，D 和 M。
字符          数值
I             1
V             5
X             10
L             50
C             100
D             500
M             1000

例如， 罗马数字 2 写做 II ，即为两个并列的 1。12 写做 XII ，即为 X + II 。 27 写做  XXVII, 即为 XX + V + II 。

通常情况下，罗马数字中小的数字在大的数字的右边。但也存在特例，例如 4 不写做 IIII，而是 IV。数字 1 在数字 5 的左边，所表示的数等于大数 5 减小数 1 得到的数值 4 。同样地，数字 9 表示为 IX。这个特殊的规则只适用于以下六种情况：

I 可以放在 V (5) 和 X (10) 的左边，来表示 4 和 9。
X 可以放在 L (50) 和 C (100) 的左边，来表示 40 和 90。 
C 可以放在 D (500) 和 M (1000) 的左边，来表示 400 和 900。
给定一个罗马数字，将其转换成整数。输入确保在 1 到 3999 的范围内。

输入: "III"
输出: 3

输入: "IV"
输出: 4

输入: "IX"
输出: 9

输入: "LVIII"
输出: 58
解释: L = 50, V= 5, III = 3.

输入: "MCMXCIV"
输出: 1994
解释: M = 1000, CM = 900, XC = 90, IV = 4.
```

## 方法

哈希，由于题目输入一种空间，而输出是另外一种空间，因此要用哈希映射咯

- 将罗马和对应的树值一一对应
- 举个例子，比如IV，假如咱们倒着遍历
- 第一轮：比如V对应5，我们可以用lastValue存
- 第二轮：I对应1，如果该值 < lastValue，则res减掉该值，res -= value
- 但如果LVI，那肯定存在该值 > lastValue，则res加上该值，res += value

## code

### js

```js
let romanToInt = function(s) {
    let m = {
        I: 1,
        V: 5,
        X: 10,
        L: 50,
        C: 100,
        D: 500,
        M: 1000
    };
    let ans = 0, lastValue = 0;
    for (let i = s.length - 1; i >= 0; i--) {
        let value = m[s[i]];
        // console.log(s[i] + " " + value);
        if (value < lastValue) {
            ans -= value;
        } else {
            ans += value;
        }
        lastValue = value;
    }
    return ans;
}
```

### go

```go
func romanToInt(s string) int {
	// map 切片
	m := make(map[string]int)
	m["I"] = 1
	m["V"] = 5
	m["X"] = 10
	m["L"] = 50
	m["C"] = 100
	m["D"] = 500
	m["M"] = 1000
	ans, lastValue:= 0, 0
	// 倒着遍历比较
	for i := len(s) - 1; i >= 0; i-- {
		value := m[string(s[i])]
		if value < lastValue {
			ans -= value
		} else {
			ans += value
		}
		lastValue = value
	}
	return ans
}
```

### java

```java
class Solution {
    public int romanToInt(String s) {
        HashMap<Character, Integer> map = new HashMap<>();
        map.put('I', 1);
        map.put('V', 5);
        map.put('X', 10);
        map.put('L', 50);
        map.put('C', 100);
        map.put('D', 500);
        map.put('M', 1000);
        int ans = 0, lastValue = 0;
        for (int i = s.length() - 1; i >= 0; i--) {
            int value = map.get(s.charAt(i));
            if (value < lastValue) {
                ans -= value;
            } else {
                ans += value;
            }
            lastValue = value;
        }
        return ans;
    }
}
```

