# 136. 只出现一次的数字

[url](https://leetcode-cn.com/problems/single-number/)


## 题目

给定一个非空整数数组，除了某个元素只出现一次以外，其余每个元素均出现两次。找出那个只出现了一次的元素。

说明：

你的算法应该具有线性时间复杂度。 你可以不使用额外空间来实现吗？

```
输入: [2,2,1]
输出: 1
输入: [4,1,2,1,2]
输出: 4
```

## 方法


两种方法：
1. 哈希->最容易想到的方法
2. 异或

## code

### js

```js
let singleNumber = nums => {
    let ret = 0;
    for (let i = 0; i < nums.length; i++) {
        ret = ret ^ nums[i];
    }
    return ret;
}
console.log(singleNumber([2, 2, 1]));
console.log(singleNumber([4,1,2,1,2]));
```

### go

```go
func singleNumber(nums []int) int {
	ret := 0
	for _, num := range nums {
		ret = ret ^ num
	}
	return ret
}
func singleNumber1(nums []int) int {
	// 哈希？
	m := make(map[int]int, len(nums))
	for _, num := range nums {
		if value, ok := m[num]; ok {
			m[num] = value + 1
		} else {
			m[num] = 1
		}
	}
	for k, v := range m {
		if v == 1 {
			return k
		}
	}
	return -1
}
```

### java

```java
class Solution {
    public int singleNumber(int[] nums) {
        int ret = 0;
        for (int num : nums) ret = ret ^ num;
        return ret;
    }
}
```

