# 191. 位1的个数

[url](https://leetcode-cn.com/problems/number-of-1-bits/)


## 题目

编写一个函数，输入是一个无符号整数（以二进制串的形式），返回其二进制表达式中数字位数为 '1' 的个数（也被称为汉明重量）。

提示：

- 请注意，在某些语言（如 `Java`）中，没有无符号整数类型。在这种情况下，输入和输出都将被指定为有符号整数类型，并且不应影响您的实现，因为无论整数是有符号的还是无符号的，其内部的二进制表示形式都是相同的。
- 在 `Java` 中，编译器使用二进制补码记法来表示有符号整数。因此，在上面的 示例 `3` 中，输入表示有符号整数 `-3`。


```
输入：00000000000000000000000000001011
输出：3
解释：输入的二进制串 00000000000000000000000000001011 中，共有三位为 '1'。
输入：00000000000000000000000010000000
输出：1
解释：输入的二进制串 00000000000000000000000010000000 中，共有一位为 '1'。
输入：11111111111111111111111111111101
输出：31
解释：输入的二进制串 11111111111111111111111111111101 中，共有 31 位为 '1'。
```
提示：

- 输入必须是长度为 `32` 的 二进制串 。

## 方法

常用：`n &= (n - 1)` 去掉二进制中的一个1

```
比如：10 & (10 - 1)
1010 - 0001 = 1001
1010 & 1001 = 1000
1000 - 0001 = 0111
1000 & 0111 = 0000
```

## code

### js

```js
let hammingWeight = n => {
    // toString(2)把十进制数字转换为二进制字符串，replace删除0，返回剩余长度
    return n.toString(2).replace(/0/g, '').length;
};
let hammingWeight1 = n => {
    let sum = 0;
    while (n !== 0) {
        sum++;
        n &= (n - 1);
    }
    return sum;
}

console.log(hammingWeight(00000000000000000000000000001011));
console.log(hammingWeight(00000000000000000000000010000000));
console.log(hammingWeight(11111111111111111111111111111101));
```

### go

```go
func hammingWeight(n int) int {
	ans := 0
	for n != 0 {
		n &= n - 1
		ans++
	}
	return ans
}
```

### java

```java
public class Solution {
    // you need to treat n as an unsigned value
    public int hammingWeight(int n) {
        int ans = 0;
        while(n != 0) {
            n &= n - 1;
            ans++;
        }
        return ans;
    }
}
```

