# 204. 计数质数

[url](https://leetcode-cn.com/problems/count-primes/)


## 题目

统计所有小于非负整数 n 的质数的数量。


```
输入：n = 10
输出：4
解释：小于 10 的质数一共有 4 个, 它们是 2, 3, 5, 7 。
输入：n = 0
输出：0
输入：n = 1
输出：0
```
提示：


## 方法

质数的概念：质数又称**素数**。 一个大于1的**自然数**，除了**1和它自身外**，**不能被其他自然数整除的数叫做质数**；否则称为合数（**规定1既不是质数也不是合数**）。

所以，嵌套for的条件`let j = 2 * i; j < n + 1; j += i`

## code

### js

```js
let coutnPrimes = n => {
    if (n < 2) return 0;
    let nums = Array(n + 1).fill(false);
    let count = 0;
    for (let i = 2; i < n; i++) {
        if (nums[i] === false) {
            count++;
        }
        for (let j = 2 * i; j < n + 1; j += i) {
            nums[j] = true;
        }
    }
    return count;
};

console.log(coutnPrimes(10));
console.log(coutnPrimes(0));
console.log(coutnPrimes(1));
```

### go

```go
func countPrimes(n int) int {
	if n < 2 {
		return 0
	}
	nums := make([]bool, n + 1)
	count := 0
	for i := 2; i < n; i++ {
		if nums[i] == false {
			count++
		}
		for j := 2 * i; j < n + 1; j += i {
			nums[j] = true
		}
	}
	return count
}
```

### java

```java
class Solution {
    public int countPrimes(int n) {
        if (n < 2) return 0;
        boolean[] num = new boolean[n + 1];
        int count = 0;
        for (int i = 2; i < n; i++) {
            if (num[i] == false) {
                count++;
            }
            for (int j = 2 * i; j < n + 1; j += i) {
                num[j] = true;
            }
        }
        return count;
    }
}
```

