# 219. 存在重复元素 II

[url](https://leetcode-cn.com/problems/contains-duplicate-ii/)


## 题目

给定一个整数数组和一个整数 `k`，判断数组中是否存在两个不同的索引 `i` 和 `j`，使得 `nums [i] = nums [j]`，并且 `i` 和 `j` 的差的绝对值至多为 `k`。

```
输入: nums = [1,2,3,1], k = 3
输出: true
输入: nums = [1,0,1,1], k = 1
输出: true
输入: nums = [1,2,3,1,2,3], k = 2
输出: false
```


## 方法

哈希

## code

### js

```js
let containsNearByDuplicate = (nums, k) => {
    let m = new Set()
    for (let i = 0; i < nums.length; i++) {
        if (m.has(nums[i])) {
            return true;
        }
        m.add(nums[i]);
        if (m.size > k) {
            m.delete(nums[i - k]);
        }
    }
    return false;
};
console.log(containsNearByDuplicate([1, 2, 3, 1], 3));
console.log(containsNearByDuplicate([1, 0, 1 ,1], 1));
console.log(containsNearByDuplicate([1, 2, 3, 1, 2, 3], 2));
```

### go

```go
func containsNearbyDuplicate(nums []int, k int) bool {
	m := make(map[int]int, len(nums))
	for i := 0; i < len(nums); i++ {
		if _, ok := m[nums[i]]; ok {
			return true
		}
		m[nums[i]] = 1
		if len(m) > k {
			delete(m, nums[i - k])
		}
	}
	return false
}
```

### java

```java
class Solution {
    public boolean containsNearbyDuplicate(int[] nums, int k) {
        HashSet<Integer> set = new HashSet<>();
        for (int i = 0; i < nums.length; i++) {
            if(set.contains(nums[i])) {
                return true;
            } 
            set.add(nums[i]);
            // 关键这里
            if (set.size() > k) {
                set.remove(nums[i - k]);
            }
        }
        return false;
    }
}
```

