# 232. 用栈实现队列

[url](https://leetcode-cn.com/problems/implement-queue-using-stacks/)


## 题目

请你仅使用两个栈实现先入先出队列。队列应当支持一般队列的支持的所有操作`（push、pop、peek、empty）`：

实现 `MyQueue` 类：

- `void push(int x)` 将元素 x 推到队列的末尾
- `int pop() `从队列的开头移除并返回元素
- `int peek()` 返回队列开头的元素
- `boolean empty()` 如果队列为空，返回 `true` ；否则，返回 `false`




## 方法

双栈实现一个队列

## code

### js

```js
let MyQueue = function () {
    this.in = [];
    this.out = [];
};
MyQueue.prototype.push = function (x) {
    this.in.push(x);
};
MyQueue.prototype.pop = function () {
    this.in2out();
    return this.out.pop();
};
MyQueue.prototype.peek = function () {
    this.in2out();
    return this.out[this.out.length - 1];
};
MyQueue.prototype.empty = function () {
    return this.in.length === 0 && this.out.length === 0;
};
MyQueue.prototype.in2out = function () {
    if (this.out.length === 0) {
        while (this.in.length !== 0) {
            this.out.push(this.in.pop());
        }
    }
};
let obj = new MyQueue();
obj.push(1);
obj.push(2);
console.log(obj.pop());
console.log(obj.peek());
console.log(obj.empty())
```

### go

```go
type MyQueue struct {
	in []int
	out []int
}
/** Initialize your data structure here. */
func Constructor() MyQueue {
	return MyQueue{}
}
func (this *MyQueue) in2out() {
	if len(this.out) == 0 {
		for len(this.in) != 0 {
			this.out = append(this.out, this.in[len(this.in) - 1])
			this.in = this.in[:len(this.in) - 1]
		}
	}
}
/** Push element x to the back of queue. */
func (this *MyQueue) Push(x int)  {
	this.in = append(this.in, x)
}

/** Removes the element from in front of queue and returns that element. */
func (this *MyQueue) Pop() int {
	this.in2out()
	value := this.out[len(this.out) - 1]
	this.out = this.out[:len(this.out) - 1]
	return value
}
/** Get the front element. */
func (this *MyQueue) Peek() int {
	this.in2out()
	return this.out[len(this.out) - 1]
}
/** Returns whether the queue is empty. */
func (this *MyQueue) Empty() bool {
	return len(this.in) == 0 && len(this.out) == 0
}
/**
 * Your MyQueue object will be instantiated and called as such:
 * obj := Constructor();
 * obj.Push(x);
 * param_2 := obj.Pop();
 * param_3 := obj.Peek();
 * param_4 := obj.Empty();
 */
```

### java

```java
class MyQueue {
    private Stack<Integer> in;
    private Stack<Integer> out;
    /** Initialize your data structure here. */
    public MyQueue() {
        in = new Stack<>();
        out = new Stack<>();
    }
    /** Push element x to the back of queue. */
    public void push(int x) {
        in.push(x);
    }
    /** Removes the element from in front of queue and returns that element. */
    public int pop() {
        in2Out();
        return out.pop();
    }
    /** Get the front element. */
    public int peek() {
        in2Out();
        return out.peek();
    }
    private void in2Out() {
        if (out.isEmpty()) {
            while (!in.isEmpty()) {
                out.push(in.pop());
            }
        }
    }
    /** Returns whether the queue is empty. */
    public boolean empty() {
        return in.isEmpty() && out.isEmpty();
    }
}
/**
 * Your MyQueue object will be instantiated and called as such:
 * MyQueue obj = new MyQueue();
 * obj.push(x);
 * int param_2 = obj.pop();
 * int param_3 = obj.peek();
 * boolean param_4 = obj.empty();
 */
```

