# 234. 回文链表

[url](https://leetcode-cn.com/problems/palindrome-linked-list/)


## 题目

请判断一个链表是否为回文链表。

示例
```
输入: 1->2
输出: false
输入: 1->2->2->1
输出: true
```


## 方法

- 快慢指针，找中点
- 切
- 反转其中一个链表与另外一个进行对比，如果相等，则是回文，否则不是

## code

### js

```js
let isPalindrome = head => {
    if (head === null || head.next === null) return true;
    // 找中点
    let slow = head, fast = head;
    while (fast !== null && fast.next !== null) {
        slow = slow.next;
        fast = fast.next.next;
    }
    if (fast !== null) slow = slow.next;
    // 切
    cur(head, slow);
    return isEquals(head, reverse(slow));
};
let cut = (head, slow) => {
    let node = head;
    while (node.next !== slow) {
        node = node.next;
    }
    node.next = null;
};
let reverse = head => {
    if head === null return null
    let pre = null, cur = head
    while (cur !== null) {
        let next = cur.next;
        cur.next = pre;
        pre = cur;
        cur = next;
    }
    return pre;
};
let isEquals = (l1, l2) => {
    while (l1 !== null && l2 !== null) {
        if (l1.val !== l2.val) return false
        l1 = l1.next;
        l2 = l2.next;
    }
    return true
}
```

### go

```go
func isPalindrome2(head *ListNode) bool {
	if head == nil || head.Next == nil {
		return true
	}
	// 找中点
	slow, fast := head, head
	for fast != nil && fast.Next != nil {
		slow = slow.Next
		fast = fast.Next.Next
	}
	if fast != nil {
		slow = slow.Next
	}
	// 切
	cut(head, slow)
	return isEquals(head, reverse2(slow))
}
func cut(head, slow *ListNode) {
	node := head
	for node.Next != slow {
		node = node.Next
	}
	node.Next = nil
}
func reverse2(node *ListNode) *ListNode {
	if node == nil {
		return nil
	}
	var pre *ListNode
	cur := node
	for cur != nil {
		next := cur.Next
		cur.Next = pre
		pre = cur
		cur = next
	}
	return pre
}
func isEquals(l1, l2 *ListNode) bool {
	for l1 != nil && l2 != nil {
		if l1.Val != l2.Val {
			return false
		}
		l1 = l1.Next
		l2 = l2.Next
	}
	return true
}
```

### java

```java
class Solution {
    public boolean isPalindrome(ListNode head) {
        if (head == null || head.next == null) return true;
        // 找中点
        ListNode slow = head, fast = head;
        while (fast != null && fast.next != null) {
            slow = slow.next;
            fast = fast.next.next;
        }
        if (fast != null) slow = slow.next;
        // 切
        cut(head, slow);

        return isEquals(head, reverse(slow));
    }
    private void cut(ListNode head, ListNode slow) {
        ListNode node = head;
        while (node.next != slow) {
            node = node.next;
        }
        node.next = null;
    }
    private ListNode reverse(ListNode node) {
        if (node == null) return null;
        ListNode pre = null;
        ListNode cur = node;
        while (cur != null) {
            ListNode next = cur.next;
            cur.next = pre;
            pre = cur;
            cur = next;
        }
        return pre;
    }
    private boolean isEquals(ListNode l1, ListNode l2) {
        while (l1 != null && l2 != null) {
            if (l1.val != l2.val) return false;
            l1 = l1.next;
            l2 = l2.next;
        }

        return false;
    }
}
```

