# 242. 有效的字母异位词

[url](https://leetcode-cn.com/problems/valid-anagram/)


## 题目

给定两个字符串 `s` 和 `t` ，编写一个函数来判断 `t` 是否是 `s` 的字母异位词。

```
输入: s = "anagram", t = "nagaram"
输出: true
输入: s = "rat", t = "car"
输出: false
```


## 方法

其实就是判断两个字符串中的对应的字符数量

- 遍历s，对应的字符++
- 遍历t，对应的字符--
- 遍历桶，如果存在不为0，则返回false

## code

### js

```js
let isAnagram = (s, t) => {
    let cnts = Array(256).fill(0);
    s = s.split("");
    t = t.split("");
    s.forEach(item => cnts[item.charCodeAt(0)]++);
    t.forEach(item => cnts[item.charCodeAt(0)]--);
    for (let value of cnts) {
        if (value !== 0) return false;
    }
    return true;
};
console.log(isAnagram("anagram", "nagaram"))
console.log(isAnagram("rat", "car"))
```

### go

```go
func isAnagram(s, t string) bool {
	cnts := make([]int, 256)
	for _, c := range s{
		cnts[c]++
	}
	for _, c := range t{
		cnts[c]--
	}
	for _, c := range cnts {
		if c != 0 {
			return false
		}
	}
	return true
}
```

### java

```java
class Solution {
    public boolean isAnagram(String s, String t) {
        int[] cnts = new int[26];
        for (char c : s.toCharArray()) {
            cnts[c - 'a']++;
        }
        for (char c : t.toCharArray()) {
            cnts[c - 'a']--;
        }
        for (int c : cnts) {
            if (c != 0) return false;
        }
        return true;
    }
}
```

