# 27. 移除元素

[url](https://leetcode-cn.com/problems/remove-element/)

## 题目

```
给你一个数组 `nums `和一个值 `val`，你需要 原地 移除所有数值等于 `val` 的元素，并返回移除后数组的新长度。

不要使用额外的数组空间，你必须仅使用 `O(1) `额外空间并 原地修改输入数组。

元素的顺序可以改变。你不需要考虑数组中超出新长度后面的元素。

给定 `nums = [3,2,2,3], val = 3`,

函数应该返回新的长度 2, 并且 `nums` 中的前两个元素均为 2。

你不需要考虑数组中超出新长度后面的元素。

给定 `nums = [0,1,2,2,3,0,4,2], val = 2`,

函数应该返回新的长度 5, 并且 `nums` 中的前五个元素为 `0, 1, 3, 0, 4`。

注意这五个元素可为任意顺序。

你不需要考虑数组中超出新长度后面的元素。
```




## 方法

双指针，其实就是一个指针固定第一个元素上，第二个指针遍历数组。
- 比如，3，2，2，3。 用一个变量p和i在3元素上的索引，
- 将索引i的元素和val的值进行比较
- 如果值不相同，将索引i的元素转移到索引p的位置上，并且将p++
- 如果相同，就i依然跟着数组遍历


## code

### js

```js{cmd="node"}
let removeElement = (nums, val) => {
    let p = 0;
    for (let i = 0; i < nums.length; i++) {
        if (nums[i] !== val)
            nums[p++] = nums[i];
    }
    console.log(nums);
    return p;
}

console.log(removeElement([3, 2, 2, 3], 3));
```

### go

```go
func removeElement(nums []int, val int) int {
	p := 0
	for i := 0; i < len(nums); i++ {
		if nums[i] != val {
			nums[p] = nums[i]
			p++
		}
	}
	fmt.Println(nums)
	return p
}
```



### java

```java
class Solution {
    public int removeElement(int[] nums, int val) {
        int p = 0;
        for (int i = 0; i < nums.length; i++){
            if (nums[i] != val)
                nums[p++] = nums[i];
        }
        return p;
    }
}
```

