# 387. 字符串中的第一个唯一字符


[url](https://leetcode-cn.com/problems/first-unique-character-in-a-string/)


## 题目

给定一个字符串，找到它的第一个不重复的字符，并返回它的索引。如果不存在，则返回 -1。




```
s = "leetcode"
返回 0
s = "loveleetcode"
返回 2
```


## 方法

## code
最容易想到的就是哈希，速战速决

### js

```js
let firstUniqChar = s => {
    let map = new Map();
    s = s.split("");
    s.forEach(c => {
       map.has(c) ? map.set(c, map.get(c) + 1) : map.set(c, 1);
    });
    for (const [i, v] of s.entries()) {
        if (map.get(v) === 1) {
            return i;
        }
    }
    return -1;
};
console.log(firstUniqChar("leetcode"))
console.log(firstUniqChar("loveleetcode"))
```

### go

```go
func firstUniqChar(s string) int {
	m := make(map[rune]int, len(s))
	for _, c := range s {
		if count, ok := m[c]; ok {
			m[c] = count + 1
		} else {
			m[c] = 1
		}
	}
	for i, c := range s {
		if m[c] == 1 {
			return i
		}
	}
	return -1
}
```

### java

```java
class Solution {
    public int firstUniqChar(String s) {
        HashMap<Character, Integer> map = new HashMap<>();
        for (char c : s.toCharArray()){
            map.put(c, map.getOrDefault(c, 0) + 1);
        }
        for (int i = 0; i < s.length(); i++) {
            if(map.get(s.charAt(i)) == 1) {
                return i;
            }
        }
        return -1;
    }
}
```

