# 414. 第三大的数


[url](https://leetcode-cn.com/problems/third-maximum-number/)


## 题目
给你一个非空数组，返回此数组中 第三大的数 。如果不存在，则返回数组中最大的数。


```
输入：[3, 2, 1]
输出：1
解释：第三大的数是 1 。
输入：[1, 2]
输出：2
解释：第三大的数不存在, 所以返回最大的数 2 。
输入：[2, 2, 3, 1]
输出：1
解释：注意，要求返回第三大的数，是指第三大且唯一出现的数。
存在两个值为2的数，它们都排第二。
```


## 方法


## code

### js

```js
let thirdMax = nums => {
    const minval = -Infinity;
    let maxFirst = minval, maxSecond = minval, maxThird = minval;
    for (let value of nums) {
        if (value > maxFirst) {
            maxThird = maxSecond;
            maxSecond = maxFirst;
            maxFirst = value;
        } else if (value < maxFirst && value > maxSecond) {
            maxThird = maxSecond;
            maxSecond = value;
        } else if (value < maxSecond && value > maxThird) {
            maxThird = value;
        }
    }
    return maxThird === minval ? maxFirst : maxThird;
};
console.log(thirdMax([3, 2 ,1]));
console.log(thirdMax([ 2 ,1]));
console.log(thirdMax([ 2 ,2 , 3, 1]));
```

### go

```go
func thirdMax(nums []int) int {
	const INT_MAX = int(^uint(0) >> 1)
	const INT_MIN = ^INT_MAX
	maxFirst, maxSecond, maxThird := INT_MIN, INT_MIN, INT_MIN
	for _, num := range nums {
		if num > maxFirst {
			maxThird = maxSecond
			maxSecond = maxFirst
			maxFirst = num
		} else if num < maxFirst && num > maxSecond {
			maxThird = maxSecond
			maxSecond = num
		} else if num < maxSecond && num > maxThird {
			maxThird = num
		}
	}
	if maxThird == INT_MIN {
		return maxFirst
	} else {
		return maxThird
	}
}
```

### java

```java
class Solution {
    public int thirdMax(int[] nums) {
        // 该方法堆
        // TreeSet<Integer> tset = new TreeSet<>();
        // for(int n:nums) {
        //     tset.add(n);
        // }
        // if(tset.size() < 3) {
        //     return tset.last();
        // } else{
        //     tset.pollLast();
        //     tset.pollLast();
        //     return tset.pollLast();
        // }
        long minVal = (long)Integer.MIN_VALUE - 1;
        long maxFirst = minVal, maxSecond = minVal, maxThird = minVal;
        for(int num : nums) {
            if(num > maxFirst) {
                maxThird = maxSecond;
                maxSecond = maxFirst;
                maxFirst = num;
            } else if(num < maxFirst && num > maxSecond) {
                maxThird = maxSecond;
                maxSecond = num;
            } else if(num < maxSecond && num > maxThird) {
                maxThird = num;
            }
        }
        return (int)(maxThird == minVal ? maxFirst : maxThird);
    }
}
```

