# 455. 分发饼干


[url](https://leetcode-cn.com/problems/assign-cookies/)


## 题目
假设你是一位很棒的家长，想要给你的孩子们一些小饼干。但是，每个孩子最多只能给一块饼干。

对每个孩子 i，都有一个胃口值 `g[i]`，这是能让孩子们满足胃口的饼干的最小尺寸；并且每块饼干 `j`，都有一个尺寸 `s[j]` 。如果 `s[j] >= g[i]`，我们可以将这个饼干 j 分配给孩子 i ，这个孩子会得到满足。你的目标是尽可能满足越多数量的孩子，并输出这个最大数值。


```
输入: g = [1,2,3], s = [1,1]
输出: 1
解释: 
你有三个孩子和两块小饼干，3个孩子的胃口值分别是：1,2,3。
虽然你有两块小饼干，由于他们的尺寸都是1，你只能让胃口值是1的孩子满足。
所以你应该输出1。
输入: g = [1,2], s = [1,2,3]
输出: 2
解释: 
你有两个孩子和三块小饼干，2个孩子的胃口值分别是1,2。
你拥有的饼干数量和尺寸都足以让所有孩子满足。
所以你应该输出2.
```

## 方法
排序+贪心

## code

### js

```js
let findContentChildren = (g, s) => {
    if (g.length === 0 || s.length === 0)
        return 0;
    let gn = g.length, sn = s.length;
    // 排序
    g.sort();
    s.sort();
    let gi = 0, si = 0;
    while (gi < gn && si < sn) {
        if (g[gi] <= s[si])
            gi++;
        si++;
    }
    return gi;
};
console.log(findContentChildren([1,2,3], [1, 1]));
console.log(findContentChildren([1,2], [1, 2, 3]));
```

### go

```go
func findContentChildren(g []int, s []int) int {
	if len(g) == 0 || len(s) == 0 {
		return 0
	}
	gn, sn := len(g), len(s)
	// 排序
	sort.Ints(g)
	sort.Ints(s)
	gi, si := 0, 0
	for gi < gn && si < sn {
		if g[gi] <= s[si] {
			gi++
		}
		si++
	}
	return gi
}
```

### java

```java
class Solution {
    public int findContentChildren(int[] g, int[] s) {
        if (g.length == 0 || s.length == 0) return 0;
        // 长度
        int gn = g.length, sn = s.length;
        // 排序
        Arrays.sort(g);
        Arrays.sort(s);
        // 双指针，贪心
        int gi = 0, si = 0;
        while (gi < gn && si < sn) {
            if (g[gi] <= s[si]) gi++;
            si++;
        }
        return gi;
    }
}
```

