# 572. 另一个树的子树


[url](https://leetcode-cn.com/problems/subtree-of-another-tree/)


## 题目
给定两个非空二叉树 s 和 t，检验 s 中是否包含和 t 具有相同结构和节点值的子树。s 的一个子树包括 s 的一个节点和这个节点的所有子孙。s 也可以看做它自身的一棵子树。


```
s:
     3
    / \
   4   5
  / \
 1   2
t:
   4 
  / \
 1   2
```
返回 true，因为 t 与 s 的一个子树拥有相同的结构和节点值。

## 方法
从下往上的思想

## code

### js

```js
let isSubtree = (s, t) => {
    if (s === null)
        return false;
    return isSubtreeWithRoot(s, t) || isSubtree(s.left, t) || isSubtree(s.right, t);
};
let isSubtreeWithRoot = (s, t) => {
  if (t === null && s === null)
      return true;
  if (t === null || s === null)
      return false;
  if (t.val !== s.val)
      return false;
  return isSubtreeWithRoot(s.left, t.left) && isSubtreeWithRoot(s.right, t.right);
};
```

### go

```go
func isSubtree(s *TreeNode, t *TreeNode) bool {
	if s == nil {
		return false
	}
	return isSubtreeWithRoot(s, t) || isSubtree(s.Left, t) || isSubtree(s.Right, t)
}
func isSubtreeWithRoot(s *TreeNode, t*TreeNode) bool {
	if t == nil && s == nil {
		return true
	}
	if t == nil || s == nil {
		return false
	}
	if t.Val != s.Val {
		return false
	}
	return isSubtreeWithRoot(s.Left, t.Left) && isSubtreeWithRoot(s.Right, t.Right)
}

```

### java

```java
class Solution {
    public boolean isSubtree(TreeNode s, TreeNode t) {
        if (s == null) return false;
        return isSubtreeWithRoot(s, t) || isSubtree(s.left, t) || isSubtree(s.right, t);
    }

    private boolean isSubtreeWithRoot(TreeNode s, TreeNode t) {
        if (t == null && s == null) return true;
        if (t == null || s == null) return false;
        if (t.val != s.val) return false;
        return isSubtreeWithRoot(s.left, t.left) && isSubtreeWithRoot(s.right, t.right);
    }
}
```

