# 594. 最长和谐子序列


[url](https://leetcode-cn.com/problems/can-place-flowers/)


## 题目
和谐数组是指一个数组里元素的最大值和最小值之间的差别 正好是 1 。

现在，给你一个整数数组 nums ，请你在所有可能的子序列中找到最长的和谐子序列的长度。

数组的子序列是一个由数组派生出来的序列，它可以通过删除一些元素或不删除元素、且不改变其余元素的顺序而得到。



```
输入：nums = [1,3,2,2,5,2,3,7]
输出：5
解释：最长的和谐子序列是 [3,2,2,2,3]
输入：nums = [1,2,3,4]
输出：2
输入：nums = [1,1,1,1]
输出：0
```

## 方法


## code

### js

```js
let findLHS = nums => {
    let map = new Map();
    nums.forEach(num => {
        if (map.has(num)) {
            map.set(num, map.get(num) + 1);
        } else {
            map.set(num , 1);
        }
    });
    let longest = 0;
    for (const key of map.keys()) {
        if (map.has(key + 1)) {
            longest = Math.max(longest, map.get(key + 1) + map.get(key));
        }
    }
    return longest;
};
console.log(findLHS([1,3,2,2,5,2,3,7]))
```

### go

```go
func findLHS(nums []int) int {
	Max := func(a int, b int) int {
		if a > b {
			return a
		} else {
			return b
		}
	}
	m := make(map[int]int, len(nums))
	for _, num := range nums {
		if v, ok := m[num]; ok {
			m[num] = v + 1
		} else {
			m[num] = 1
		}
	}
	longest := 0
	for _, k := range m {
		if v, ok := m[k+1]; ok {
			longest = Max(longest, v+m[k])
		}
	}
	return longest
}
```

### java

```java
class Solution {
    public int findLHS(int[] nums) {
        Map<Integer, Integer> map = new HashMap<>();
        for (int num : nums) {
            map.put(num, map.getOrDefault(num, 0) + 1);
        } 
        int longest = 0;
        for (int num : map.keySet()) {
            if (map.containsKey(num + 1)) {
                longest = Math.max(longest, map.get(num + 1) + map.get(num));
            }
        }
        return longest;
    }
}
```

