# 6. Z 字形变换

[url](https://leetcode-cn.com/problems/zigzag-conversion/)

## 题目

将一个给定字符串 s 根据给定的行数 numRows ，以从上往下、从左到右进行 Z 字形排列。

比如输入字符串为 "PAYPALISHIRING" 行数为 3 时，排列如下：

```
P   A   H   N
A P L S I I G
Y   I   R
```
之后，你的输出需要从左往右逐行读取，产生出一个新的字符串，比如："PAHNAPLSIIGYIR"。

请你实现这个将字符串进行指定行数变换的函数：
```
string convert(string s, int numRows);
```
```
输入：s = "PAYPALISHIRING", numRows = 3
输出："PAHNAPLSIIGYIR"
输入：s = "PAYPALISHIRING", numRows = 4
输出："PINALSIGYAHRPI"
解释：
P     I    N
A   L S  I G
Y A   H R
P     I
输入：s = "A", numRows = 1
输出："A"
```

## 方法

```
// 0|     1   5   9     13
// 1|     2 4 6 8 10 12 14 16
// 2|     3   7   11    15
// 每一行右边的字符的 ’索引值’ 都是其左边的字符的 ’索引值’ 加上它 ’下面剩余行数’ 的两倍或 ’上面行数’ 的两倍（交替相加）
// 以第二行为例，
// 对于4这个字符而言， 4 = 2(左边的索引) + 2(两倍) * 1(下面有一行)
// 6 = 4 + 2 * 1(上面有一行)
// 8 = 6 + 2 * 1(下面有一行)
```

## code

### js

```js
let convert = (s, numRows) => {
    if (numRows <= 1)
        return s;
    let res = "";
    for (let i = 0; i < numRows; i++) {
        let up = i, down = numRows - 1 - i;
        let tmp = i, cnt = 0;
        while (tmp < s.length) {
            if (cnt % 2 === 0 && down !== 0) {
                res += s[tmp];
                tmp += 2 * down;
            } else if (cnt % 2 !== 0 && up !== 0) {
                res += s[tmp];
                tmp += 2 * up;
            }
            cnt++;
        }
    }
    return res;
};
```

### go

```go
func convert(s string, numRows int) string {
	if numRows == 1 {
		return s
	}
	res := ""
	for i := 0; i < numRows; i++ {
		up := i
		down := numRows - 1 - i
		temp := i
		cnt := 0
		for temp < len(s) {
			if cnt%2 == 0 && down != 0 {
				res += string(s[temp])
				temp += 2 * down
			} else if cnt%2 != 0 && up != 0 {
				res += string(s[temp])
				temp += 2 * up
			}
			cnt++
		}
	}
	return res
}
```

### java

```java
class Solution {
    public String convert(String s, int numRows) {
        if (numRows <= 1)
            return s;
        
        char[] cs = s.toCharArray();
        String res = "";
        for (int i = 0; i < numRows; i++){
            int up = i; // 上方的行数
            int down = numRows - 1 - i; // 下方的行数
            int temp = i;
            int cnt = 0;
            while (temp < cs.length){
                if (cnt % 2 == 0 && down != 0) {
                    res += cs[temp];
                    temp += 2 * down;
                } else if(cnt % 2 != 0 && up != 0){
                    res += cs[temp];
                    temp += 2 * up;
                }
                cnt++;
            }
        }
        return res;
    }
}
```

