# 637. 二叉树的层平均值


[url](https://leetcode-cn.com/problems/average-of-levels-in-binary-tree/)


## 题目
给定一个非空二叉树, 返回一个由每层节点平均值组成的数组。


```
输入：
    3
   / \
  9  20
    /  \
   15   7
输出：[3, 14.5, 11]
解释：
第 0 层的平均值是 3 ,  第1层是 14.5 , 第2层是 11 。因此返回 [3, 14.5, 11] 。
```


## 方法


## code

### js

```js
let averageOfLevels = root => {
    let ret = [];
    if (root === null)
        return ret;
    let queue = [root];
    while (queue.length !== 0) {
        let cnt = queue.length;
        let sum = 0;
        for (let i = 0; i < cnt; i++) {
            let node = queue[0];
            queue = queue.slice(1, queue.length - 1);
            sum += node.val;
            if (node.left !== null)
                queue.push(node.left);
            if (node.right !== null)
                queue.push(node.right);
        }
        ret.push(sum / cnt);
    }
    return ret;
};
```

### go

```go
func averageOfLevels(root *TreeNode) []float64 {
	ret := make([]float64, 0)
	if root == nil {
		return ret
	}
	q := []*TreeNode{root}
	for len(q) != 0 {
		curQ := q
		q = nil
		sum := 0
		for _, node := range curQ {
			sum += node.Val
			if node.Left != nil {
				q = append(q, node.Left)
			}
			if node.Right != nil {
				q = append(q, node.Right)
			}
		}
		ret = append(ret, float64(sum) / float64(len(curQ)))
	}
	return ret
}
```

### java

```java
class Solution {
    public List<Double> averageOfLevels(TreeNode root) {
        List<Double> ret = new ArrayList<>();
        if (root == null) return ret;
        Queue<TreeNode> queue = new LinkedList<>();
        queue.add(root);
        while (!queue.isEmpty()) {
            int cnt = queue.size();
            double sum = 0;
            for (int i = 0; i < cnt; i++) {
                TreeNode node = queue.poll();
                sum += node.val;
                if (node.left != null) queue.add(node.left);
                if (node.right != null) queue.add(node.right);
            }
            ret.add(sum / cnt);
        }
        return ret;
    }
}
```

