# 66. 加一

[url](https://leetcode-cn.com/problems/plus-one/)

## 题目

给定一个由 整数 组成的 非空 数组所表示的非负整数，在该数的基础上加一。

最高位数字存放在数组的首位， 数组中每个元素只存储单个数字。

你可以假设除了整数 0 之外，这个整数不会以零开头。

```
输入：digits = [1,2,3]
输出：[1,2,4]
解释：输入数组表示数字 123。

输入：digits = [4,3,2,1]
输出：[4,3,2,2]
解释：输入数组表示数字 4321。

输入：digits = [0]
输出：[1]
```

## 方法

这道题挺简单的，主要是考察进位

- 经常用到 x % 10 得到该数的最后一位数字
- 配合sum / 10 得到进位

## code

### js

```js
let plusOne = digits => {
    let length = digits.length;
    let res = [];
    let carry = 1;
    for (let i = length - 1; i >= 0; i--) {
        let sums = digits[i] + carry;
        res[i] = sums % 10;
        carry = Math.floor(sums / 10);
    }
    if (carry === 1) {
        res[0] = 1;
        return res;
    }
    return res.copyWithin(res, 0, length);
}

console.log(plusOne([1, 2, 3]));
console.log(plusOne([4, 3, 2, 1]));
console.log(plusOne([0]));
```

### go

```go
func plusOne(digits []int) []int {
	length := len(digits)
	res := make([]int, length + 1)
	carry := 1
	for i := length - 1; i >= 0; i-- {
		sum := digits[i] + carry
		res[i] = sum % 10
		carry = sum / 10
	}
	if carry == 1 {
		res[0] = 1
		return res
	}
	return res[0:length]
}
```



### java

```java
class Solution {
    public int[] plusOne(int[] digits) {
        int length = digits.length;
        int[] res = new int[length + 1];
        int carry = 1;
        for (int i = length - 1; i >= 0 ; i--) {
            int sums = digits[i] + carry;
            res[i] = sums % 10;
            carry = sums / 10;
        }
        if (carry == 1) {
            res[0] = 1;
            return res;
        }
        return Arrays.copyOfRange(res,0,length);

    }
}
```

