# 70. 爬楼梯

[url](https://leetcode-cn.com/problems/climbing-stairs/)

## 题目

假设你正在爬楼梯。需要 n 阶你才能到达楼顶。

每次你可以爬 1 或 2 个台阶。你有多少种不同的方法可以爬到楼顶呢？

注意：给定 n 是一个正整数。

```
输入： 2
输出： 2
解释： 有两种方法可以爬到楼顶。
1.  1 阶 + 1 阶
2.  2 阶
输入： 3
输出： 3
解释： 有三种方法可以爬到楼顶。
1.  1 阶 + 1 阶 + 1 阶
2.  1 阶 + 2 阶
3.  2 阶 + 1 阶
```

## 方法

从下往上迭代

- 当`n=1，n=2`的时候，结果为`1,2`。
- 从`n=3`开始，计算`cur = pre2 + pre1`
- 接着替换pre2，pre1
- 迭代完毕，返回pre1


## code

### js

```js
let climbStairs = n => {
    if (n <= 2) return n;
    let pre2 = 1, pre1 = 2;
    for (let i = 3; i <= n; i++) {
        let cur = pre2 + pre1;
        pre2 = pre1;
        pre1 = cur;
    }
    return pre1;
}
console.log(climbStairs(2));
console.log(climbStairs(3));
console.log(climbStairs(4));
```

### go

```go
func climbStairs(n int) int {
	if n <= 2 {
		return n
	}
	pre2, pre1 := 1, 2
	for i := 3; i <= n; i++ {
		cur := pre2 + pre1
		pre2 = pre1
		pre1 = cur
	}
	return pre1
}
```



### java

```java
class Solution {
    public int climbStairs(int n) {
        if (n <= 2) return n;
        int pre2 = 1, pre1 = 2;
        for (int i = 3; i <= n; i++) {
            int cur = pre2 + pre1;
            pre2 = pre1;
            pre1 = cur;
        }
        return pre1;
    }
}
```

