# 744.寻找比目标字母大的最小字母


[url](https://leetcode-cn.com/problems/find-smallest-letter-greater-than-target/)


## 题目
给你一个排序后的字符列表 letters ，列表中只包含小写英文字母。另给出一个目标字母 target，请你寻找在这一有序列表里比目标字母大的最小字母。

在比较时，字母是依序循环出现的。举个例子：

如果目标字母 target = 'z' 并且字符列表为 letters = ['a', 'b']，则答案返回 'a'

```
letters = ["c", "f", "j"]
target = "a"
输出: "c"

输入:
letters = ["c", "f", "j"]
target = "c"
输出: "f"

输入:
letters = ["c", "f", "j"]
target = "d"
输出: "f"

输入:
letters = ["c", "f", "j"]
target = "g"
输出: "j"

输入:
letters = ["c", "f", "j"]
target = "j"
输出: "c"

输入:
letters = ["c", "f", "j"]
target = "k"
输出: "c"
```


## 方法


## code

### js

```js
let nextGreatestLetter = (letters, target) => {
    let n = letters.length;
    let l = 0, h = n - 1;
    while (l <= h) {
        let m = l + Math.floor((h - l) / 2);
        if (letters[m] <= target)
            l = m + 1;
        else
            h = m - 1;
    }
    return l < n ? letters[l] : letters[0];
};
console.log(nextGreatestLetter(["c", "f", "j"], "a"))
console.log(nextGreatestLetter(["c", "f", "j"], "c"))
console.log(nextGreatestLetter(["c", "f", "j"], "d"))
console.log(nextGreatestLetter(["c", "f", "j"], "g"))
```

### go

```go
func nextGreatestLetter(letter []byte, target byte) byte {
	n := len(letter)
	l, h := 0, n - 1
	for l <= h {
		m := l + (h - l) / 2
		if letter[m] <= target {
			l = m + 1
		} else {
			h = m - 1
		}
	}
	if l < n {
		return letter[l]
	} else {
		return letter[0]
	}
}
```

### java

```java
class Solution {
    public char nextGreatestLetter(char[] letters, char target) {
        int n = letters.length;
        int l = 0, h = n - 1;
        while (l <= h) {
            int m = l + (h - l) / 2;
            if (letters[m] <= target) l = m + 1;
            else h = m - 1;
        }
        return l < n ? letters[l] : letters[0];
    }
}
```

