# 747. 至少是其他数字两倍的最大数


[url](https://leetcode-cn.com/problems/largest-number-at-least-twice-of-others/)


## 题目
在一个给定的数组nums中，总是存在一个最大元素 。

查找数组中的最大元素是否至少是数组中每个其他数字的两倍。

如果是，则返回最大元素的索引，否则返回-1。


```
输入: nums = [3, 6, 1, 0]
输出: 1
解释: 6是最大的整数, 对于数组中的其他整数,
6大于数组中其他元素的两倍。6的索引是1, 所以我们返回1.
输入: nums = [1, 2, 3, 4]
输出: -1
解释: 4没有超过3的两倍大, 所以我们返回 -1.
```


## 方法


## code

### js

```js
let dominantIndex = nums => {
    // 将第二大的元素的两倍与最大值做比较
    // 如果最大值大，那么就能证明最大值大于所有元素的两倍
    let max = 0, idx = 0, less = 0;
    for (const [i, val] of nums.entries()) {
        if (val > max) {
            less = max;
            max = val;
            idx = i;
        } else if (val > less && val !== max) {
            less = val;
        }
    }
    return max >= (less * 2) ? idx : -1;
};
console.log(dominantIndex([3, 6, 1, 0]))
console.log(dominantIndex([1, 2, 3, 4]))
```

### go

```go
func dominantIndex(nums []int) int {
	max, idx, less := 0 , 0, 0
	for i, v := range nums {
		if v > max {
			less = max
			max = v
			idx = i
		} else if v > less && v != max {
			less = v
		}
	}
	if max >= (less * 2) {
		return idx
	} else {
		return -1
	}
}
```

### java

```java
class Solution {
    public int dominantIndex(int[] nums) {
        // 将第二大的元素的两倍与最大值做比较
        // 如果最大值大，那么就能证明最大值大于所有元素的两倍
        int max = 0, idx = 0, less = 0;
        for (int i = 0; i < nums.length; i++) {
            if (nums[i] > max) {
                less = max;
                max = nums[i];
                idx = i;
            } else if(nums[i] > less && nums[i] != max) {
                less = nums[i];
            }
        }
        return max >= (less * 2) ? idx : -1;
    }
}
```

