# 9. 回文数

[url](https://leetcode-cn.com/problems/palindrome-number/)

## 题目

判断一个整数是否是回文数。回文数是指正序（从左向右）和倒序（从右向左）读都是一样的整数。

```
输入: 121
输出: true

输入: -121
输出: false
解释: 从左向右读, 为 -121 。 从右向左读, 为 121- 。因此它不是一个回文数。

输入: 10
输出: false
解释: 从右向左读, 为 01 。因此它不是一个回文数。
```

## 方法

y = y * 10 + x % 10
x /= 10

二者使用效果极佳
- 和整数反转差不多的思想

## code

### js

```js
let isPalindrome = x => {
    if (x === 0)
        return true;
    if (x < 0 || x % 10 === 0)
        return false;
    let right = 0;
    while (x > right) { // 核心步骤
        right = right * 10 + x % 10;
        x = (x / 10) | 0;
    }
    return x === right ? x === right : x === ((right / 10) | 0)
};
```

### go

```go
func isPalindrome(x int) bool {
	if x == 0 {
		return true
	}
	if x < 0 || x % 10 == 0 {
		return false
	}
	right := 0
	for x > right {
		right = right * 10 + x % 10
		x /= 10
	}
	if x == right {
		return true
	} else {
		return x == right / 10
	}
}
```

### java

```java
class Solution {
    public boolean isPalindrome(int x) {
        if (x == 0)
            return true;
        if (x < 0 || x % 10 == 0)
            return false;
        int right = 0;
        while (x > right) {
            right = right * 10 + x % 10;
            x /= 10;
        }
        return x == right ? x == right : x == right / 10;
    }
}
```

