# 类加载过程

面试官：谈一谈类加载过程

我：加载->验证->准备->解析->初始化

![类加载过程](https://gitee.com/dreamcater/blog-img/raw/master/uPic/类加载过程-5A2XIO.png)

## 加载

类加载过程的第一步，主要完成下面3件事情：

- 通过**全类名**获取定义此类的**二进制字节流**
- 将字节流所代表的**静态存储结构**转换为方法区的**运行时数据结构**
- 在内存中生成一个代表该类的 **Class 对象**,作为**方法区这些数据的访问入口**

## 验证

- 文件格式验证：主要验证Class文件**是否规范**等。
- 元数据验证：对字节码描述的信息**语义分析**等。
- 字节码验证：确保语义是ok的。
- 符号引用验证：确保解析动作能执行。

## 准备

**准备阶段是正式为类变量分配内存并设置类变量初始值的阶段**，这些内存都将在方法区中分配。对于该阶段有以下几点需要注意：

- 这时候进行内存分配的仅包括**类变量**（static），而不包括实例变量，实例变量会在对象实例化时随着对象一块分配在 Java 堆中。
- 这里所设置的初始值"通常情况"下是数据类型默认的**零值**（如0、0L、null、false等），比如我们定义了`public static int value=111` ，那么 value 变量在准备阶段的初始值就是 0 而不是111（初始化阶段才会复制）。特殊情况：比如给 value 变量加上了 **fianl 关键字**`public static final int value=111` ，那么准备阶段 value 的值就被复制为 111。

## 解析

解析阶段是虚拟机将常量池内的**符号引用替换为直接引用**的过程，也就是得到**类或者字段、方法在内存中的指针或者偏移量。**

## 初始化

初始化是类加载的最后一步，也是真正执行类中定义的 **Java 程序代码**(字节码)，初始化阶段是执行**类构造器** `<clinit> ()`方法的过程。

