
## Java

- JVM分区
- 垃圾收集算法
- synchronized原理
- 双亲委派机制
- 线程池参数
- newFixedTheadPool底层，优缺点
- springmvc
- @Autowired原理
- springboot原理
- @OnConditionalClass实现原理
- @OnMissingBean没有bean会怎么样，会classNotFound
- HashMap 底层数据结构
- HashMap 什么时候扩容？装载因子和临界值默认是多少？扩容成多大？为什么容量是2的幂次方？
- 线程安全的Map？分段锁是如何实现的？JDK 1.8之后有哪些优化？
- Lock和Synchronized区别
- AQS实现
- 锁优化
- String StringBuilder StringBuffer区别，特点，场景
- ConcurrentMap 源码
- CMS
- 线程生命周期（状态）
- ReentrantLock与AQS同步框架
- CAS原理是什么？
- synchronize原理是什么？
- springboot 和 spring 的区别是什么？
- spring中bean的初始化过程
- 谈一谈异常机制
- Spring IOC和AOP
- Arrays.sort()底层原理

## 场景题
- 一个8G的服务器，堆的大小应该设置成多少
- 海量数据求频率最多的100个
- spring一个事务中调用另外一个事务，另一个- 事务发生异常会怎么样
- 一个父类加载器能不能加载一个子类加载器，为什么
- select * from A where id in (select id from B)怎么优化
- 一个16G的内存堆分配多少，采用什么垃圾收集器，为什么用cms不用g1，为什么(面试官一直问为什么使用cms或者使用g1，回答了这两个的优缺点之后还是不满意)
- 多线程解析一个超大文件怎么处理，如果文件切分的时候关键信息被分到了不同的解析线程中怎么办
- hashset是如何判断两个对象相等的
- 如何要两个对象相等equals和hashcode这两个方法要怎么重写
- hash算法(最开始讲hash冲突算法，面试官说不是这个，我又说对hash值对质数取余，面试官也说不是这个，不知道他要我回答啥。。。)
- 不使用任何优化，直接访问数据库，如何优化 （提示 redo、undo log的开销）（这里应该还可以答：批处理、连接池等）
- 行锁锁的是索引，如果一个表没有主键怎么加锁？（锁表）
- hashmap 为什么不直接用红黑树，还要用链表？
- 红黑树的特性？各种操作的时间复杂度？最多旋转几次达到平衡？
- finally 中 return 会发生什么？
- 如何破坏双亲委派
- 浏览器中用户信息和密码的安全有没有考虑过
- 两个线程如何交替打印A和B
- 100万个数，数据类型是int，给你8核CPU，8G内存，如何求数组的和？
- 很多个不重复的数，假设用的数组来装，我希望你实现一个方法，每次调用这个方法给我随机返回100个不重复，记住是随机的。
- 四个引用的具体应用场景
- 垃圾回收器具体应用场景
- 可达性分析算法具体应用场景
- 垃圾回收器参数调优（给具体场景 大概就是并发低延时）
- 高并发多连接jvm 线程池参数调优（顺着来）
- 高并发系统调优（再顺一下）
- 队列与栈的 应用场景
- 点赞高并发怎么办？
- 消息中间件用过么？怎么自己设计一个消息中间件？
- 假设catch，final，catch中有return，那么final还会不会执行
- 假设1亿的11位的手机号，运行空间128M，如果要进行排序，那么要怎么设计
- jvm的设计角度，gc你怎么优化？
- 你怎么设计md5函数？
- cpu一直被占满，怎么排查？
- 让你自己设计一个垃圾回收器，尽可能提高回收效率，你会怎么设计？（ZGC和香浓多，整就完事了）
- MD5加密算法，不使用hashmap和映射，你自己来设计一个同类型的，给定字符串可以生成64位随机数的，你怎么设计
- 利用java现有的东西，让你设计一个对象，实现类似synchronize的功能，使得多个线程不冲突，你如何设计？（ThreadLocal玩起来）
- synchronize锁定.class和锁定一个实例有什么区别？
- explain中的key字段的值等于ref时，有没有触发索引？
- 如何实现单点登录，如何实现权限控制，用户密码泄露后如何保证安全性
- spring中循环依赖如何解决？如果让你来实现你怎么做？
- 如果我的服务器ip地址变了，客户端如何感知到呢？
- 轮询的负载均衡的缺点是什么？如何改进？
- 让你来实现真正的负载均衡，你如何做？（我回答记录每台服务器在最近的一段时间内接收的请求的数量，每次都把请求发送给数量最小的服务器，后来面试官提醒我还应当考虑每个请求耗费的时间）
- 秒杀项目中静态资源CDN怎么做？
- css文件能放到CDN上吗？
- 秒杀缓存如何与数据库的数据保持一致性？
- 通过广播的方式去更新每个节点的缓存，如果某个节点的缓存更新失败，那么如何排查是哪个节点呢？
- 消费者消费失败是怎么处理的
- 如何保证消息消费的顺序性
- 如何保证消息不被重复消费
- 项目中要进行分布式扩展应该怎么做
- 缓存和mysql数据一致性如何保证
- 微信步数排行，假设百万级用户，怎么排序，实时更新（我说排序就是海量数据排序的方式分组排序再归并，然后实时更新的话也是组内更新组内排序，但是每组的分度值可能不一样，比如0-2000可能一组，但2000-4000可能要分五组之类的，因为步数特别少和特别多的都是少数。）
- 发生了OOM，应该怎么去分析解决？jvm调优
- 什么时候发生线程的上下文切换？
- CAS是硬件实现还是软件实现
- 除了wait和notifyall，还有什么办法实现类似的功能
- 微信抢红包设计（只讲了类似多线程抢、Semphore，缓存）、海量文件找重复次数最多的个数（分治）

## MySQL
- 索引怎么优化
- 为什么用B+树
- Innodb 和 Myisam 的区别
- 聚集索引和非聚集索引 创建以后的文件大小
- 为什么不用哈希索引？
- 有几种事务隔离级别？
- Innodb 行锁是如何实现的？
- mysql怎么分页
- 索引为什么查找快
- 慢查询如何优化
- mvcc原理

## Redis
- redis基本数据类型
- redis集群？切片
- 为什么用Redis，Redis宕机了怎么办，数据呢？怎么保持热点数据？过期机制，淘汰机制？
- redis是单线程么？为什么快？io模型什么怎么样的，具体是怎么个流程？
- 缓存穿透、雪崩，redis持久化机制

## 计网
- tcp三次握手
- HTTP 和RPC区别？还有呢？
- JWT流程，安全？Session？
- 盐有单独保存起来么
- HTTP 和 HTTPS的区别
- https的加密证书怎么获取
- 加密后客户端保留的是公钥还是私钥
- 讲一下ftp
- cookies
- http以及https 以及加密手段
- 浏览器输入url后的一系列操作
- HTTP状态码
- 为什么用Jwt,cookie，session有什么好处？
- TCP怎么确保可靠性的？丢包和串包怎么办？
- DNS说一下？

## 操作系统
- 上下文切换
- 内核态用户态
- 多路复用IO模型，select，poll，epoll

## 分布式
- 怎么实现分布式锁
- redis分布式锁有什么缺点，怎么解决
- 单体应用和微服务区别，为什么要有微服务？好处？还有呢？
- 微服务流程？
- 分布式缓存？
- 分布式session原理
- SpringCloud及其组件你了解哪些？


## 算法
- n个线程顺序循环打印0-100
- 手写LinkedList的数据结构并写出add和remove算法
- 微信红包算法实现
- 链表如何找环
- 有序链表合并
- 共计9个苹果，有2只猴子，一个猴子每次拿2个苹果，一个猴子每次拿3个苹果，如果剩余的苹果不够猴子每次拿的数量，则2只猴子停止拿苹果，请用java多线程模拟上面的描述，要求性能尽可能高效（这个题开始是用可重入锁写的，结束之后自己本地测试发现程序不会自动结束，后来改成用AtomicInteger和cas来实现了）
- 设计一个多线程打印程序，第i个线程只打印i-1数字，比如第1个线程打印数字0，第2个线程只打印数字1，依次类推。任意给定一个数字序列，比如3382019835830，能够使用该程序打印出来。
